% plot stdy scalp map for ERSP

function [ STUDY, com ] = pop_erspscalpmap(STUDY, ALLEEG, plottf, subject);
    
    if nargin < 2
        help pop_erspscalpmap;
        return;
    end;
    
    if isstr(STUDY),
        
        if strcmpi(STUDY, 'studyparams')
            
            TMPSTUDY = get(ALLEEG, 'userdata')
            TMPSTUDY{1} = pop_erspparams(TMPSTUDY{1});
            set(ALLEEG, 'userdata', TMPSTUDY);
            return;
            
        else % plot
            
            TMPSTUDY = get(ALLEEG, 'userdata');
            time     = str2num(get(findobj(ALLEEG, 'tag', 'time'), 'string'));
            freq     = str2num(get(findobj(ALLEEG, 'tag', 'freq'), 'string'));
            subject  = get(findobj(ALLEEG, 'tag', 'subject'), 'value');
            if subject == 1, subject = '';
            else subject = TMPSTUDY{1}.subject{subject-1};
            end;
            
            tmplocs = eeg_mergelocs(TMPSTUDY{2}.chanlocs);
            TMPSTUDY{1} = std_erspplot(TMPSTUDY{1}, TMPSTUDY{2}, 'channels', { tmplocs.labels }, 'plottf', [ freq time ], 'subject', subject);
            set(ALLEEG, 'userdata', TMPSTUDY);
            return;
        end;
        return;
        
    end;
    if ~isfield(STUDY, 'changrp')
        STUDY = std_changroup(STUDY, ALLEEG);
    elseif isempty(STUDY.changrp)
        STUDY = std_changroup(STUDY, ALLEEG);
    end;    
    
    if nargin < 4, subject = ''; end;
    
    if nargin < 3
        
        uilist = { ...
        {'style' 'text'       'string' 'Time in ms'} ...
        {'style' 'edit'       'string' '' 'tag' 'time' } ...
        {'style' 'text'       'string' 'Freq. in Hz'} ...
        {'style' 'edit'       'string' '' 'tag' 'freq' } ...
        {'style' 'text'       'string' 'Subject'} ...
        {'style' 'popupmenu'  'string' strvcat('All', STUDY.subject{:}) 'tag' 'subject' } ...
        {'style' 'pushbutton' 'string' 'stat. parameters' 'callback' 'pop_erspscalpmap(''studyparams'', gcbf);' } ...
        {} ...
        {} { 'style' 'pushbutton' 'string' 'Plot' 'callback' 'pop_erspscalpmap(''plot'', gcbf);' } {} };
        
        geometry = { [1 1 1 1] [1 1 1.9] [1] [1 1 1] };
        
        [result userdata tmp tagres] = inputgui('geometry', geometry, 'uilist', uilist, 'title', 'ERSP scalp map', 'userdata', { STUDY ALLEEG });
        if isempty(result), return; end;
        
        STUDY = userdata{1};
        
        plottf  = [ str2num(tagres.freq) str2num(tagres.time) ];
        if tagres.subject > 1, subject = STUDY.subject{tagres.subject-1}; end;
        
    end;
        
    tmplocs = eeg_mergelocs(ALLEEG.chanlocs);
    STUDY = std_erspplot(STUDY, ALLEEG, 'channels', { tmplocs.labels }, 'plottf', plottf, 'subject', subject);
        
    com = sprintf('tmplocs = eeg_mergelocs(ALLEEG.chanlocs); STUDY = std_erspplot(STUDY, ALLEEG, ''channels'', { tmplocs.labels }, ''plottf'', %s, ''subject'', %s);', vararg2str({ plottf }), vararg2str({ subject }));
