% plot stdy scalp map for SPEC

function [ STUDY, com ] = pop_specscalpmap(STUDY, ALLEEG, plotfreq, subject);
    
    if isstr(STUDY),
        
        if strcmpi(STUDY, 'studyparams')
            
            TMPSTUDY = get(ALLEEG, 'userdata')
            TMPSTUDY{1} = pop_specparams(TMPSTUDY{1});
            set(ALLEEG, 'userdata', TMPSTUDY);
            return;
            
        else % plot
            
            TMPSTUDY = get(ALLEEG, 'userdata');
            freq     = str2num(get(findobj(ALLEEG, 'tag', 'freq'), 'string'));
            subject  = get(findobj(ALLEEG, 'tag', 'subject'), 'value');
            if subject == 1, subject = '';
            else subject = TMPSTUDY{1}.subject{subject-1};
            end;
            
            tmplocs = eeg_mergelocs(TMPSTUDY{2}.chanlocs);
            TMPSTUDY{1} = std_specplot(TMPSTUDY{1}, TMPSTUDY{2}, 'channels', { tmplocs.labels }, 'plotfreq', [ freq ], 'subject', subject);
            set(ALLEEG, 'userdata', TMPSTUDY);
            return;
        end;
    end;
    
    
    if nargin < 4, subject = ''; end;
    
    if nargin < 3
        
        uilist = { ...
        {'style' 'text'       'string' 'Freq. in Hz'} ...
        {'style' 'edit'       'string' '' 'tag' 'freq' } {} {} ...
        {'style' 'text'       'string' 'Subject'} ...
        {'style' 'popupmenu'  'string' strvcat('All', STUDY.subject{:}) 'tag' 'subject' } ...
        {'style' 'pushbutton' 'string' 'stat. parameters' 'callback' 'pop_specscalpmap(''studyparams'', gcbf);' } ...
        {} ...
        {} { 'style' 'pushbutton' 'string' 'Plot' 'callback' 'pop_specscalpmap(''plot'', gcbf);' } {} };
        
        geometry = { [1 1 1 1] [1 1 1.9] [1] [1 1 1] };
        
        [result userdata tmp tagres] = inputgui('geometry', geometry, 'uilist', uilist, 'title', 'Spetrum scalp map', 'userdata', { STUDY ALLEEG });
        if isempty(result), return; end;
        
        STUDY = userdata{1};
        
        plotfreq  = [ str2num(tagres.freq) ];
        if tagres.subject > 1, subject = STUDY.subject{tagres.subject-1}; end;
        
    end;
        
    tmplocs = eeg_mergelocs(ALLEEG.chanlocs);
    STUDY = std_specplot(STUDY, ALLEEG, 'channels', { tmplocs.labels }, 'plotfreq', plotfreq, 'subject', subject);
        
    com = sprintf('tmplocs = eeg_mergelocs(ALLEEG.chanlocs); STUDY = std_specplot(STUDY, ALLEEG, ''channels'', { tmplocs.labels }, ''plotfreq'', %s, ''subject'', %s);', vararg2str({ plotfreq }), vararg2str({ subject }));
